Index: libabac/abac_xml.h
===================================================================
--- libabac/abac_xml.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
+++ libabac/abac_xml.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -0,0 +1,19 @@
+/* abac_xml.h */
+#ifndef __ABAC_XML_H__
+#define __ABAC_XML_H__
+
+extern void read_cert(char *filename, char **buf, int *len);
+extern char *my_make_credential(char* rt0, int secs, char* cert, int certlen);
+extern void fatal(const char *str);
+
+extern int init_xmlsec();
+extern int deinit_xmlsec();
+extern char **my_read_credential(char *infile, char **xml);
+
+extern char **get_rt0_from_xml(char *xml);
+extern char *get_keyid_from_xml(char *xml);
+extern long get_validity_from_xml(char *xml);
+
+#endif /* __ABAC_XML_H__ */
+
+
Index: libabac/compat/readpassphrase.c
===================================================================
--- libabac/compat/readpassphrase.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
+++ libabac/compat/readpassphrase.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -0,0 +1,209 @@
+/*	$OpenBSD: readpassphrase.c,v 1.23 2010/05/14 13:30:34 millert Exp $	*/
+
+/*
+ * Copyright (c) 2000-2002, 2007, 2010
+ *	Todd C. Miller <Todd.Miller@courtesan.com>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Sponsored in part by the Defense Advanced Research Projects
+ * Agency (DARPA) and Air Force Research Laboratory, Air Force
+ * Materiel Command, USAF, under agreement number F39502-99-1-0512.
+ */
+
+/* OPENBSD ORIGINAL: lib/libc/gen/readpassphrase.c */
+
+/**
+ * Tom Carroll <thomas.carroll@pnnl.gov>
+ *
+ * Properly handled tcsetattr and SIGTTOU
+ */
+
+#ifndef HAVE_READPASSPHRASE
+
+#include <ctype.h>
+#include <errno.h>
+#include <fcntl.h>
+#ifdef HAVE_PATHS_H
+# include <paths.h>
+#endif
+#include <signal.h>
+#include <string.h>
+#include <termios.h>
+#include <unistd.h>
+#include "compat/readpassphrase.h"
+
+#ifndef TCSASOFT
+# define TCSASOFT 0
+#endif
+
+#ifndef NSIG
+# ifdef _NSIG
+#  define NSIG _NSIG
+# else
+#  define NSIG 128
+# endif
+#endif
+
+static volatile sig_atomic_t signo[NSIG];
+
+static void handler(int);
+
+char *
+readpassphrase(const char *prompt, char *buf, size_t bufsiz, int flags)
+{
+	ssize_t nr;
+	int input, output, save_errno, i, need_restart;
+	char ch, *p, *end;
+	struct termios term, oterm;
+	struct sigaction sa, savealrm, saveint, savehup, savequit, saveterm;
+	struct sigaction savetstp, savettin, savettou, savepipe;
+
+	/* I suppose we could alloc on demand in this case (XXX). */
+	if (bufsiz == 0) {
+		errno = EINVAL;
+		return(NULL);
+	}
+
+restart:
+	for (i = 0; i < NSIG; i++)
+		signo[i] = 0;
+	nr = -1;
+	save_errno = 0;
+	need_restart = 0;
+	/*
+	 * Read and write to /dev/tty if available.  If not, read from
+	 * stdin and write to stderr unless a tty is required.
+	 */
+	if ((flags & RPP_STDIN) ||
+	    (input = output = open(_PATH_TTY, O_RDWR)) == -1) {
+		if (flags & RPP_REQUIRE_TTY) {
+			errno = ENOTTY;
+			return(NULL);
+		}
+		input = STDIN_FILENO;
+		output = STDERR_FILENO;
+	}
+
+	/*
+	 * Turn off echo if possible.
+	 * If we are using a tty but are not the foreground pgrp this will
+	 * generate SIGTTOU, so do it *before* installing the signal handlers.
+	 */
+	if (input != STDIN_FILENO && tcgetattr(input, &oterm) == 0) {
+		memcpy(&term, &oterm, sizeof(term));
+		if (!(flags & RPP_ECHO_ON))
+			term.c_lflag &= ~(ECHO | ECHONL);
+#ifdef VSTATUS
+		if (term.c_cc[VSTATUS] != _POSIX_VDISABLE)
+			term.c_cc[VSTATUS] = _POSIX_VDISABLE;
+#endif
+		(void)tcsetattr(input, TCSAFLUSH|TCSASOFT, &term);
+	} else {
+		memset(&term, 0, sizeof(term));
+		term.c_lflag |= ECHO;
+		memset(&oterm, 0, sizeof(oterm));
+		oterm.c_lflag |= ECHO;
+	}
+
+	/*
+	 * Catch signals that would otherwise cause the user to end
+	 * up with echo turned off in the shell.  Don't worry about
+	 * things like SIGXCPU and SIGVTALRM for now.
+	 */
+	sigemptyset(&sa.sa_mask);
+	sa.sa_flags = 0;		/* don't restart system calls */
+	sa.sa_handler = handler;
+	(void)sigaction(SIGALRM, &sa, &savealrm);
+	(void)sigaction(SIGHUP, &sa, &savehup);
+	(void)sigaction(SIGINT, &sa, &saveint);
+	(void)sigaction(SIGPIPE, &sa, &savepipe);
+	(void)sigaction(SIGQUIT, &sa, &savequit);
+	(void)sigaction(SIGTERM, &sa, &saveterm);
+	(void)sigaction(SIGTSTP, &sa, &savetstp);
+	(void)sigaction(SIGTTIN, &sa, &savettin);
+	(void)sigaction(SIGTTOU, &sa, &savettou);
+
+	if (!(flags & RPP_STDIN))
+		(void)write(output, prompt, strlen(prompt));
+	end = buf + bufsiz - 1;
+	p = buf;
+	while ((nr = read(input, &ch, 1)) == 1 && ch != '\n' && ch != '\r') {
+		if (p < end) {
+			if ((flags & RPP_SEVENBIT))
+				ch &= 0x7f;
+			if (isalpha(ch)) {
+				if ((flags & RPP_FORCELOWER))
+					ch = (char)tolower(ch);
+				if ((flags & RPP_FORCEUPPER))
+					ch = (char)toupper(ch);
+			}
+			*p++ = ch;
+		}
+	}
+	*p = '\0';
+	save_errno = errno;
+	if (!(term.c_lflag & ECHO))
+		(void)write(output, "\n", 1);
+
+	/* Restore old terminal settings and signals. */
+	if (memcmp(&term, &oterm, sizeof(term)) != 0) {
+		sigset_t ttou_sigset, old_sigset;
+		sigemptyset(&ttou_sigset);
+		sigaddset(&ttou_sigset, SIGTTOU);
+		sigprocmask(SIG_BLOCK, &ttou_sigset, &old_sigset);
+		while (tcsetattr(input, TCSAFLUSH|TCSASOFT, &oterm) == -1 &&
+		    errno == EINTR)
+			continue;
+		sigprocmask(SIG_SETMASK, &old_sigset, NULL);
+	}
+	(void)sigaction(SIGALRM, &savealrm, NULL);
+	(void)sigaction(SIGHUP, &savehup, NULL);
+	(void)sigaction(SIGINT, &saveint, NULL);
+	(void)sigaction(SIGQUIT, &savequit, NULL);
+	(void)sigaction(SIGPIPE, &savepipe, NULL);
+	(void)sigaction(SIGTERM, &saveterm, NULL);
+	(void)sigaction(SIGTSTP, &savetstp, NULL);
+	(void)sigaction(SIGTTIN, &savettin, NULL);
+	(void)sigaction(SIGTTOU, &savettou, NULL);
+	if (input != STDIN_FILENO)
+		(void)close(input);
+
+	/*
+	 * If we were interrupted by a signal, resend it to ourselves
+	 * now that we have restored the signal handlers.
+	 */
+	for (i = 0; i < NSIG; i++) {
+		if (signo[i]) {
+			kill(getpid(), i);
+			switch (i) {
+			case SIGTSTP:
+			case SIGTTIN:
+			case SIGTTOU:
+				need_restart = 1;
+			}
+		}
+	}
+	if (need_restart)
+		goto restart;
+
+	return(nr == -1 ? errno = save_errno, NULL : buf);
+}
+
+static void handler(int s)
+{
+
+	signo[s] = 1;
+}
+
+#endif /* ! HAVE_READPASSPHRASE */
Index: libabac/compat/readpassphrase.h
===================================================================
--- libabac/compat/readpassphrase.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
+++ libabac/compat/readpassphrase.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -0,0 +1,42 @@
+/*	$OpenBSD: readpassphrase.h,v 1.5 2003/06/17 21:56:23 millert Exp $	*/
+
+/*
+ * Copyright (c) 2000, 2002 Todd C. Miller <Todd.Miller@courtesan.com>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Sponsored in part by the Defense Advanced Research Projects
+ * Agency (DARPA) and Air Force Research Laboratory, Air Force
+ * Materiel Command, USAF, under agreement number F39502-99-1-0512.
+ */
+
+#ifndef _READPASSPHRASE_H_
+#define _READPASSPHRASE_H_
+
+#ifndef HAVE_READPASSPHRASE
+
+#define RPP_ECHO_OFF    0x00		/* Turn off echo (default). */
+#define RPP_ECHO_ON     0x01		/* Leave echo on. */
+#define RPP_REQUIRE_TTY 0x02		/* Fail if there is no tty. */
+#define RPP_FORCELOWER  0x04		/* Force input to lower case. */
+#define RPP_FORCEUPPER  0x08		/* Force input to upper case. */
+#define RPP_SEVENBIT    0x10		/* Strip the high bit from input. */
+#define RPP_STDIN       0x20		/* Read from stdin, not /dev/tty */
+
+#include <stddef.h>
+
+char * readpassphrase(const char *, char *, size_t, int);
+
+#endif /* ! HAVE_READPASSPHRASE */
+
+#endif /* !_READPASSPHRASE_H_ */
Index: libabac/libabac_common.h
===================================================================
--- libabac/libabac_common.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
+++ libabac/libabac_common.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -0,0 +1,36 @@
+#ifndef __LIBABAC_COMMON_H__
+#define __LIBABAC_COMMON_H__
+
+#include "abac.h"
+
+void libabac_init();
+
+/* helper functions */
+
+// generate a random serial (8byte)
+unsigned char *abac_generate_serial();
+
+// returns true if a name starts with a letter and 
+//  is otherwise alphanumeric
+int abac_clean_name(char *string);
+
+// return a PEM blob of the ID cert
+abac_chunk_t abac_id_in_PEM(abac_id_t *id);
+
+// return a PEM blob of the ID/PKEY 
+int abac_id_PEM(abac_id_t *id, abac_chunk_t *);
+
+// return a blob of the Attribute cert
+abac_chunk_t abac_attribute_cert(abac_attribute_t *ptr);
+
+// called by abac_verifier 
+int init_xmlsec();
+int deinit_xmlsec();
+
+// called by abac_verifier
+int init_openssl();
+int deinit_openssl();
+
+
+#endif /* __LIBABAC_COMMON_H__ */
+
Index: libabac/options.c
===================================================================
--- libabac/options.c	(revision d4b3b529e2089c1d6789e5f0d05d99ff3aa4c533)
+++ libabac/options.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -1,2 +1,6 @@
+
+/* options.c */
+
+#include <stdio.h>
 #include <getopt.h>
 #include <stdlib.h>
@@ -10,4 +14,5 @@
         "        --keystore <keystore> \\\n"
         "        --role <keyid.role> --principal <keyid>\n"
+        "        --dump <file>\n"
         "    loads the keystore and runs the query role <-?- principal\n",
         name
@@ -20,8 +25,10 @@
 #define OPT_ROLE        2
 #define OPT_PRINCIPAL   3
+#define OPT_DUMP        4
     struct option options[] = {
         { "keystore",   1, 0, OPT_KEYSTORE  },
         { "role",       1, 0, OPT_ROLE      },
         { "principal",  1, 0, OPT_PRINCIPAL },
+        { "dump",       1, 0, OPT_DUMP },
         { 0 },
     };
@@ -42,4 +49,8 @@
                 opts->principal = strdup(optarg);
                 break;
+            case OPT_DUMP:
+                opts->rulefile = strdup(optarg);
+                break;
+
 
             default:
@@ -48,5 +59,5 @@
     }
 
-    if (!(opts->keystore && opts->role && opts->principal))
+    if (!(opts->keystore && opts->role && opts->principal) && !(opts->rulefile) )
         _usage(argv[0]);
 }
Index: libabac/options.h
===================================================================
--- libabac/options.h	(revision d4b3b529e2089c1d6789e5f0d05d99ff3aa4c533)
+++ libabac/options.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -10,4 +10,5 @@
     char *role;
     char *principal;
+    char *rulefile;
 } options_t;
 
Index: libabac/prover.c
===================================================================
--- libabac/prover.c	(revision d4b3b529e2089c1d6789e5f0d05d99ff3aa4c533)
+++ libabac/prover.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -15,4 +15,21 @@
     abac_context_t *ctx = abac_context_new();
     abac_context_load_directory(ctx, opts.keystore);
+
+    if(opts.rulefile) {
+        FILE *fp=fopen(opts.rulefile,"w+");
+        if(fp) { 
+            abac_credential_t **credentials = abac_context_credentials(ctx);
+            if (credentials != NULL)
+                for (i = 0; credentials[i] != NULL; ++i) {
+                    cred = credentials[i];
+                    fprintf(fp,"%s <- %s\n",
+                            abac_role_string(abac_credential_head(cred)),
+                            abac_role_string(abac_credential_tail(cred))
+                          );
+                }
+            abac_context_credentials_free(credentials);
+            fclose(fp);
+        }
+    }
 
     abac_credential_t **credentials = abac_context_query(ctx,
